unit thucobar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TBarHStyle=(bheight1,bheight2,bheight3,bheight4,bheight5);
  TPRate=(PR1,PR2,PR3,PR4,PR5);
  THeadStrHeight=1..5;
  TBEWord=(A,B,C,D);
  CordBarStr = array [0..19] of String[7];
  THUCodeBar = class(TGraphicControl)
  private
    { Private declarations }
    FPicture:TPicture;
    FHeadStr :String;
    FHeadStrHeight:THeadStrHeight;
    FFirstWord:TBEWord;
    FBarcodeStr:String;
    FLastWord:TBEWord;
    FBarcodeHeight:TBarHStyle;
    FBarColor:TColor;
    FShowBarStr:Boolean;
    FCheckWord:Boolean;
    FAutoSize:Boolean;
    FPrintRate:TPRate;
    FTransparent:Boolean;
    procedure SetHeadStr(Value:String);
    procedure SetHeadStrHeight(Value:THeadStrHeight);
    Procedure SetFirestWord(Value:TBEWord);
    procedure SetBarcodeStr(Value:String);
    Procedure SetLastWord(Value:TBEWord);
    procedure SetBarColor(Value:TColor);
    procedure SetShowBarStr(Value:Boolean);
    procedure SetBarcodeHeight(Value:TBarHStyle);
    procedure SetAutoSize(Value:Boolean);
    procedure SetCheckWord(Value:Boolean);
    procedure SetPicture(Value:TPicture);
    Procedure SetPrintRate(Value:TPRate);
    Procedure SetTransparent(Value:Boolean);
    procedure DrawBarCode(TargetCanvas : TCanvas; Barstr,DrawCode : String; PX,PY,PH,PFact,wordh,wordhf :integer);
    function  GetBarString(Value:String):String;
    function  GetCanvas:TCanvas;
    function  BarDecode(Value:String):String;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
  protected
    { Protected declarations }
    procedure Paint; override;
  public
    { Public declarations }
    constructor Create(AOwner : TComponent);override;
    destructor  Destroy; override;
    property Canvas: TCanvas read GetCanvas;
  published
    { Published declarations }
    property HeadStr:String read FHeadStr write SetHeadStr;
    property HeadStrHeight:THeadStrHeight read FHeadStrHeight Write SetHeadStrHeight default 1;
    property FirstWord:TBEWord read FFirstWord write SetFirestWord default A;
    property BarStr:String read FBarcodeStr write SetBarcodeStr;
    property LastWord:TBEWord read FLastWord write SetLastWord default A;
    property BarcodeColor:TColor read FBarColor write SetBarColor default clBlack;
    property BarcodeHeight:TBarHStyle read FBarcodeHeight write SetBarcodeHeight default bheight3;
    property ShowBarStr:boolean read FShowBarStr Write SetShowBarStr Default True;
    property CheckWord:Boolean read FCheckWord write SetCheckWord Default False;
    property AutoSize:boolean read FAutosize write SetAutoSize Default True;
    property Picture:Tpicture read Fpicture write SetPicture;
    property PrintRate:TPRate read FPrintRate write SetPrintRate default PR3;
    property Transparent:Boolean read FTransparent write SetTransparent default False;

    property Height default 54;
    property Width default 120;
    Property Font;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

procedure Register;

implementation
uses Consts;

 const
 // cord bar rX
 CordBarChk:String[20]='abcd0123456789+-/$:.';

 CordBarWord : CordBarStr =
 ('0011010',// a
  '0101001',// b
  '0001011',// c
  '0001110',// d
  '0000011',// 0
  '0000110',// 1
  '0001001',// 2
  '1100000',// 3
  '0010010',// 4
  '1000010',// 5
  '0100001',// 6
  '0100100',// 7
  '0110000',// 8
  '1001000',// 9
  '0010101',// +
  '0001100',// -
  '1010001',// /
  '0011000',// $
  '1000101',// :
  '1010100'// .
  );

constructor THUCodeBar.Create(AOwner : TComponent);
begin
 inherited Create(AOwner);
 FPicture:=TPicture.Create;
 FFirstWord:=A;
 FLastWord:=A;
 FHeadStrHeight:=1;
 FBarcodeHeight:=bheight3;
 FBarColor:=clBlack;
 FShowBarStr:=True;
 FAutoSize:=True;
 Height := 54;
 Width := 120;
 FTransparent:=False;
 FPrintRate:=PR3;
 FCheckWord:=False;
end;

destructor  THUCodeBar.Destroy;
begin
  FPicture.Free;
  inherited Destroy;
end;

procedure THUCodeBar.DrawBarCode(TargetCanvas : TCanvas; Barstr,DrawCode: String; PX,PY,PH,PFact,wordh,wordhf :integer);
Var
 wordcont,linecont,lop,lop1,BarInd,barna : Integer;
 ch : Char;
 barcode : String[22];
 Flags:Word;
 Rect: TRect;
Begin
 Flags:=DT_CENTER or DT_WORDBREAK;
 Rect.Left:=PX;
 Rect.Top:=PY;
 Rect.Right:=(Width-5)*PFact;
 Rect.Bottom:=Rect.Top+wordh*FHeadstrHeight+wordhf*(FHeadStrHeight-1)+2*PFact;
 if FShowBarStr and (Length(FHeadStr)>0) then
   DrawText(TargetCanvas.Handle, PChar(FHeadStr), Length(FHeadStr), Rect, Flags);
 barna:=0;
  linecont:=Length(DrawCode);

  TargetCanvas.Pen.Width := PFact;
  TargetCanvas.Pen.Color:=FBarColor;
  for lop1:=1 to linecont do begin
   if DrawCode[lop1]='1' then begin
     if FShowBarStr and (Length(FHeadStr)>0) then begin
      TargetCanvas.MoveTo(PX+barna*PFact,PY+wordh*FHeadStrHeight+2*PFact+wordhf*(FHeadStrHeight-1));
      TargetCanvas.LineTo(PX+barna*PFact,PY+PH*PFact+wordh*FHeadStrHeight+2*PFact+wordhf*(FHeadStrHeight-1));
     end
     else
     begin
      TargetCanvas.MoveTo(PX+barna*PFact,PY);
      TargetCanvas.LineTo(PX+barna*PFact,PY+PH*PFact);
     end;
   end;
   barna:=barna+1;
  end;
 Rect.Left:=PX;
 Rect.Right:=(Width-5)*PFact;
 if FShowBarStr and (Length(FHeadStr)>0) then
 begin
  Rect.Top:=PY+PH*PFact+wordh*FHeadStrHeight+4*PFact+wordhf*(FheadStrHeight-1);
  Rect.Bottom:=Rect.Top+wordh;
 end
 else
 begin
  Rect.Top:=PY+PH*PFact+2*PFact;
  Rect.Bottom:=Rect.Top+wordh;
 end;
 if FShowBarStr  then
   DrawText(TargetCanvas.Handle, PChar(UpperCase(Barstr)), Length(Barstr), Rect, Flags);
End;

function THUCodeBar.GetBarString(Value:String):String;
 var
     TempStr:String;
     lop,wordcont:integer;
     ch:Char;
begin
 wordcont:=Length(Value);
 Result:='';
 for lop:=1 to wordcont do begin
    ch:=value[lop];
   case ch of
    '0','1','2','3','4','5','6','7','8','9','a','b',
    'c','d','+','-','/','$',':','.'
     : begin
        TempStr:=ch;
        Result:=Result+TempStr;
       end;
   end;
 end;
end;

function THUCodeBar.GetCanvas: TCanvas;
var
  Bitmap: TBitmap;
begin
  if Picture.Graphic = nil then
  begin
    Bitmap := TBitmap.Create;
    try
      Bitmap.Width := Width;
      Bitmap.Height := Height;
      Picture.Graphic := Bitmap;
    finally
      Bitmap.Free;
    end;
  end;
  if Picture.Graphic is TBitmap then
    Result := TBitmap(Picture.Graphic).Canvas
  else
    raise EInvalidOperation.CreateRes(SImageCanvasNeedsBitmap);
end;


procedure THUCodeBar.SetHeadStr(Value:String);
begin
  if Value <> FHeadStr then
  begin
    FHeadStr:=Value;
    Invalidate;
  end;
end;

procedure THUCodeBar.SetFirestWord(Value:TBEWord);
begin
  if Value <> FFirstWord then
  begin
    FFirstWord:=Value;
    Invalidate;
  end;
end;

procedure THUCodeBar.SetBarcodeStr(Value:String);
begin
  if Value <> FBarcodeStr then
  begin
    if (Length(Value)<=30) then
    begin
      FBarcodeStr:=Value;
      Invalidate;
    end
    else
      ShowMessage('BarcodeStr Length great then 30!!');
  end;
end;

procedure THUCodeBar.SetLastWord(Value:TBEWord);
begin
  if Value <> FLastWord then
  begin
    FLastWord:=Value;
    Invalidate;
  end;
end;

procedure THUCodeBar.SetBarcodeHeight(Value:TBarHStyle);
begin
  if Value <> FBarcodeHeight then
  begin
   FBarcodeHeight:=Value;
   Invalidate;
  end;
end;

procedure THUCodeBar.SetBarColor(Value:TColor);
begin
  if Value <> FBarColor then
  begin
    FBarColor:=Value;
    Invalidate;
  end;
end;

procedure THUCodeBar.SetHeadStrHeight(Value:THeadStrHeight);
begin
  if Value <> FHeadStrHeight then
  begin
   FHeadStrHeight:=Value;
   Invalidate;
  end;
end;


procedure THUCodeBar.SetShowBarStr(Value:Boolean);
begin
  if Value <> FShowBarStr then
  begin
    FShowBarStr:= Value;
    invalidate;
  end;
end;

procedure THUCodeBar.SetCheckWord(Value:Boolean);
begin
  if Value <> FCheckWord then
  begin
    FCheckWord:= Value;
    invalidate;
  end;
end;

procedure THUCodeBar.SetAutoSize(Value: Boolean);
begin
  if FAutoSize <> Value then
  begin
    FAutoSize := Value;
    invalidate;
  end;
end;

procedure THUCodeBar.SetPicture(Value: TPicture);
begin
  FPicture.Assign(Value);
end;

Procedure THUCodeBar.SetPrintRate(Value:TPRate);
begin
  if FPrintRate <> Value then
  begin
    FPrintRate := Value;
    invalidate;
  end;
end;

Procedure THUCodeBar.SetTransparent(Value:Boolean);
begin
  if FTransparent <> Value then
  begin
    FTransparent := Value;
    invalidate;
  end;
end;

procedure THUCodeBar.CMTextChanged(var Message: TMessage);
begin
  Invalidate;
end;

procedure THUCodeBar.CMFontChanged(var Message: TMessage);
begin
  inherited;
end;

function THUCodeBar.BarDecode(Value:String):String;
var
  TmpStr:String;
  l,i:integer;
begin
  l:=Length(Value);
  TmpStr:='';
  for i:=1 to l do
  begin
    if (i mod 2)=1 then
    begin
      if Value[i] = '1' then
        TmpStr:=TmpStr+'111'
      else
        TmpStr:=TmpStr+'1';
    end
    else
    begin
      if Value[i] = '1' then
        TmpStr:=TmpStr+'000'
      else
        TmpStr:=TmpStr+'0';
    end;
    Result:=TmpStr;
  end;
end;

procedure THUCodeBar.Paint;
 var PX,PY,PH,PFact,barLength,DrawCodeLen,i,BarIndx,wordh,wordhf,wordth:integer;
     Barcode,DrawCode:String;
     PCanvasRect:TRect;
     ch,fw,lw:Char;
begin

  case FBarcodeHeight of
    bheight1:  PH:=12;
    bheight2:  PH:=24;
    bheight3:  PH:=36;
    bheight4:  PH:=48;
    bheight5:  PH:=60;
  end;
  PX:=5;
  PY:=5;
  PFact:=1;
  if Length(BarStr) > 0 then
  begin
   Barcode:=BarStr;

   Barcode:=GetBarString(LowerCase(Barcode));
   case FFirstword of
     A: fw:='a';
     B: fw:='b';
     C: fw:='c';
     D: fw:='d';
   end;
   case FLastword of
     A: lw:='a';
     B: lw:='b';
     C: lw:='c';
     D: lw:='d';
   end;

   Barcode:=fw+Barcode+lw;
  end
  else
   Barcode:='';

  BarLength:=Length(Barcode);
  DrawCode:='';
  for i:=1 to BarLength do
  begin
    ch:= Barcode[i];
   case ch of
   'a': BarIndx:=0;
   'b': BarIndx:=1;
   'c': BarIndx:=2;
   'd': BarIndx:=3;
   '0': BarIndx:=4;
   '1': BarIndx:=5;
   '2': BarIndx:=6;
   '3': BarIndx:=7;
   '4': BarIndx:=8;
   '5': BarIndx:=9;
   '6': BarIndx:=10;
   '7': BarIndx:=11;
   '8': BarIndx:=12;
   '9': BarIndx:=13;
   '+': BarIndx:=14;
   '-': BarIndx:=15;
   '/': BarIndx:=16;
   '$': BarIndx:=17;
   ':': BarIndx:=18;
   '.': BarIndx:=19;
   end;
   DrawCode:=DrawCode+BarDecode(CordBarWord[BarIndx])+'0';
  end;
  DrawCodeLen:=Length(DrawCode);

  wordh:= abs(Font.Height); // r
  wordhf:= wordh div 2;     // rC
  wordth:=0;
  if ShowBarStr then
  begin
    if Length(FHeadStr)>0 then
     wordth:=wordth+wordh*FHeadStrHeight+2+wordhf*(FHeadStrHeight-1);
    if Length(FBarcodeStr)>0 then
     wordth:=wordth+wordh+2;
  end;
  if FAutoSize then
  begin
    Height:=PH+10+wordth; // 10 WUwdצU 5
    Width:=DrawCodeLen+7;
  end;

// e component Canvas
  with inherited Canvas do
  begin
    Font := self.Font;
    Brush.Style := bsClear;
    if FTransparent then
     Brush.Color := Self.Color
    else
     Brush.Color := clWhite;
    FillRect(ClientRect);
  end;
  DrawBarCode( inherited Canvas, Barcode,DrawCode, PX,PY,PH,PFact,wordh,wordhf);


 // e picture Canvas
  PFact:=integer(FPrintRate);
  Canvas.Font := self.Font;
  Canvas.Brush.Style := bsClear;
  if FTransparent then
    Canvas.Brush.Color := Self.Color
  else
  begin
    Canvas.Brush.Color := clWhite;
  end;
  PCanvasRect:=ClientRect;
  PCanvasRect.Right:=PCanvasRect.Right*PFact;
  PCanvasRect.Bottom:=PCanvasRect.Bottom*PFact;
  Canvas.FillRect(PCanvasRect);
  FPicture.Graphic.Height:=Height*PFact;
  FPicture.Graphic.Width:=Width*PFact;

  Canvas.Font.Size:=Canvas.Font.Size*PFact;
  wordh:= abs(Canvas.Font.Height);
  wordhf:= wordh div 2 ;
  wordth:=0;
  if ShowBarStr then
  begin
    if Length(FHeadStr)>0 then
     wordth:=wordth+wordh*FHeadStrHeight+2*PFact+wordhf*(FHeadStrHeight-1);
    if Length(FBarcodeStr)>0 then
     wordth:=wordth+wordh+2*PFact;
  end;
  PX:=PX*PFact;
  PY:=PY*PFact;

  DrawBarCode( Canvas, Barcode,DrawCode, PX,PY,PH,PFact,wordh,wordhf);
end;

procedure Register;
begin
  RegisterComponents('THU', [THUCodeBar]);
end;

end.
